﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using Sedodream.Sudoku.Board;
using Sudoku.Web.MVC.Binders;

namespace Sudoku.Web.MVC
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default",                                              // Route name
                "{controller}/{action}/{id}",                           // URL with parameters
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
            );

            //routes.MapRoute(
            //    "Default2",                                              // Route name
            //    "{controller}/{action}/{startBoardString}",             // URL with parameters
            //    new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
            //);
        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);

            RegisterBinders();
        }

        protected void RegisterBinders()
        {
            ModelBinders.Binders.Add(typeof(IBoard), new BoardBinder());
        }
    }
}